// *********************************************************************
//			NList Class
// Here we define the functions for the class NList. All you need to
// manipulate a List of Points. This version uses two pointers, one to
// the previous node and the other to the next node (double linked list).
// A particular node named "sentinel" indicates the end of list.
// Initial version:	09/12/97
// *********************************************************************
// 	$Id: NList.cpp,v 1.2 1999/09/09 14:51:23 avillani Exp $	


#ifndef lint
static char vcid[] = "$Id: NList.cpp,v 1.2 1999/09/09 14:51:23 avillani Exp $";
#endif /* lint */


#include <stdlib.h>
#include <iostream.h>

#include "NList.H"


// BaseNList empty constructor
BaseNList::BaseNList()
{
  sentinel = new ListBaseNode;			// Build the sentinel node
  sentinel->next = sentinel->prev = sentinel;

  current = sentinel;

  len = 0;
}


// BaseNList destructor
BaseNList::~BaseNList()
{
  GoToFirst();

  while (!IsEndOfList())
    Delete();

  delete sentinel;
}


// Empty the list but not destroy it
NListPos BaseNList::Clear()
{
  GoToFirst();

  while (!IsEndOfList())
    Delete();

  return(current);
}


// Insert a "link" before current
NListPos BaseNList::Insert(ListBaseNode* d)
{
  d->prev = current->prev;
  d->next = current;

  current->prev = d;
  d->prev->next = d;

  len++;

  return(d);
}


// Insert a "link" before the first node
NListPos BaseNList::InsertFirst(ListBaseNode* d)
{
  GoToFirst();

  return(Insert(d));
}


// Insert a "link" beyond the last node
NListPos BaseNList::InsertLast(ListBaseNode* d)
{
  GoToLast();

  return(Insert(d));
}


// Remove current 
ListBaseNode* BaseNList::Delete()
{
  if (IsEndOfList()) {
    GenericException theexcept("BaseNList::Delete",
			       "You can't delete the sentinel.");

    // Throw the exception
    throw (theexcept);
  }

  ListBaseNode *tmpp = current;	// Save the current position

  current->next->prev = current->prev;
  current->prev->next = current->next;

  len--;

  current = current->next;	// Move the current position

  return(tmpp);			// Return the pointer to the node detached 
}
